#!/usr/bin/python

__doc__ = "POP Account Base Classes"
__version__ = "0.0.1"

import string

try:
	from OFS.Folder import Folder
except:
	class Folder:
		""" nothing but a debugging tool"""


class POPFolderBase(Folder):
	"""
	Mix-in Class for POP Account Folder Instances
	"""

	def createAccount(user, passwd, server):
		pass # do this later

class POPMailAccountBase:
    def __init__(self, user='noname', passwd='nopass', server='noserver'):
	  self.user = user
	  self.passwd = passwd
	  self.server = server


    def Connect(self):
	  import poplib

	  sock = poplib.POP3(self.server)
	  sock.user(self.user)
	  sock.pass_(self.passwd)

	  return sock


    def ServerStatus(self, sock=None):
	  if sock == None:
	  	sock = self.Connect()
	  result = sock.getwelcome()
	  return result

    def Status(self, sock=None):
	  if sock == None:
	  	sock = self.Connect()
	  messagecount, mailboxsize = sock.stat()
	  return {'MessageCount':messagecount, 'MailboxSize':mailboxsize }

    def MessageCount(self, sock=None):
	statusdict = self.Status()

	return statusdict['MessageCount']

    def ParseMessageHeader(self, header, message):
	fromline = "none"
	toline = "none"
	sline = "none"
	dateline = "none"

	message_id, message_size = string.split(message)

	for mline in header:
	   if string.find(string.lower(mline), "from:") == 0:
		fromline = string.join(string.split(mline, ":")[1:])
	   elif string.find(string.lower(mline), "to:") == 0:
		toline = string.join(string.split(mline, ":")[1:])
	   elif string.find(string.lower(mline), "subject:") == 0:
		sline = string.join(string.split(mline, ":")[1:])
	   elif string.find(string.lower(mline), "date:") == 0:
		dateline = string.join(string.split(mline, ":")[1:])

	message = { "message_id" : message_id,
		    "from" : fromline,
		    "to" : toline,
		    "subject" : sline,
		    "date" : dateline,
		    "message_size" : message_size
		  }

	return message
		    

    def ListMessages(self, sock=None):
	  if sock == None:
	  	sock = self.Connect()

	  status, messagelist, octets = sock.list()

	  returnMessages = []

	  for message in messagelist:
	      message_id, message_size = string.split(message)
	      resultcode, messageheader, octets = sock.top(message_id, 0)

	      fullmessage = self.ParseMessageHeader(messageheader, message)


	      returnMessages.append(fullmessage)

	  return returnMessages


    def GetMessage(self, message_id, sock=None):
	  if sock == None:
	  	sock = self.Connect()
	  resultcode, messageheader, octets = sock.top(message_id, 0)
	  status, message, octets = sock.retr(message_id)

	  messagebody = message[len(messageheader):]
	  return string.join(messagebody, "<BR>\n")

    def DeleteMessage(self, messageID, sock=None):
	  if sock == None:
	  	sock = self.Connect()
	  sock.dele(messageID)


    def ResetMailbox(self):
	  if sock == None:
	  	sock = self.Connect()

    def CloseSocket(self, sock):
	  sock.quit()


    def MessageTest(self):
	  return "Message Test"
